Bug 3936 - Faulty error code if file is locked and "Delete Pending"
Faulty error code if file is locked and "Delete Pending"
Status: NEW
Product: Samba 3.0
Classification: Unclassified
Component: File Services
All Linux
: P3 normal
: none
Assigned To: Samba Bugzilla Account
Samba QA Contact
Depends on:
  Show dependency treegraph
Reported: 2006-07-15 07:16 UTC by Dirk Wolfanger
Modified: 2006-07-19 09:42 UTC (History)
0 users

See Also:

Ethereal Sniffs, Samba Dbg 10 (10.97 KB, application/octet-stream)
2006-07-17 00:27 UTC, Dirk Wolfanger
no flags Details
Test program, Logs (59.51 KB, application/octet-stream)
2006-07-19 09:42 UTC, Dirk Wolfanger
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Dirk Wolfanger 2006-07-15 07:16:20 UTC
Assume a file has share-mode lock "DENY_ALL" + attribute "DELETE_PENDING".
If a program tries to access this file, Samba returns the error-code "NT_STATUS_DELETE_PENDING", but it should return "NT_STATUS_SHARING_VIOLATION".

FileMon output:

File.1 exists with attributes as mentioned.

2003 Server:
1	13:52:17	CREATE	Y:\Program\File.1	SHARING VIOLATION	
	Options: OverwriteIf  Access: All	

Samba Server:	
1	13:52:53	CREATE	Z:\Program\File.1	DELETE PEND	
	Options: OverwriteIf  Access: All	
2	13:52:53	OPEN	Z:\Program\File.1	DELETE PEND	
	Options: Open  Access: All
Comment 1 Volker Lendecke 2006-07-15 11:57:13 UTC
Sounds very interesting... :-)

Can you send a complete sniff of your application leading to the error? This would make it very easy to write a torture test, check against W2k3 and make sure we behave correctly.


Comment 2 Dirk Wolfanger 2006-07-17 00:27:58 UTC
Created attachment 2041 [details]
Ethereal Sniffs, Samba Dbg 10

Here are the sniffs (file creation, file read XP + Samba)
and parts from a level 10 Samba debug output.
The Windows Sniffs (file creation + file read xp) are between
XP Workstations. For a real W3k Sniff, you'll have to wait till weekend.
Comment 3 Volker Lendecke 2006-07-17 14:21:49 UTC
Sorry, but I can not reproduce the bug here with the information you provided. Please post complete traces leading to the error, not just snippets of some packets. Please also try with 3.0.23 or 3.0.23a which is about to released very soon.


Comment 4 Dirk Wolfanger 2006-07-19 09:42:06 UTC
Created attachment 2048 [details]
Test program, Logs

sorry for the “snippets” but I couldn’t actually sent >70MB of l10 debug log (amount generated by application starting, without actual “Access-Tests”). 
So I wrote my own test program. It’s attached (Source VC + Win32 executable). 
If you try it, you’ll have to use 2 Workstations otherwise the tests will “fail”; XP isn’t accessing the real file on the share if the program is executed a second time on the same machine.
I’ve attached a full l10 log of my application on two workstations accessing the 
Test-file (see readme).
I’ve tried with 3.0.23. Now it seems my problem is even bigger because I can’t even create my Test-file anymore. 3.0.23 l10 Debug is attached.
Any help appreciated …